﻿using System;
using System.Web.UI;
using uForum.Businesslogic;
using uForum.Businesslogic.Services;

namespace uForum.usercontrols.uForum
{
    public partial class NewForumTopic : UserControl
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            AuthorizationService auth = new AuthorizationService();
            Rights rights = auth.GetRights(ForumId);
            if (!rights.CanPost)
            {
                mvwControls.SetActiveView(vwLogin);
            }
        }

        protected void create_Click(object sender, EventArgs e)
        {
            PostingService service = new PostingService();

            int forumid = ForumId;
            string title = titleTextbox.Text;
            string body = topicBodyTextbox.Text;
            try
            {
                string topicUrl = service.NewTopic(forumid, title, body);
                Response.Redirect(topicUrl);
            }
            catch (ArgumentException ex)
            {
                litErrorText.Text = ex.Message;
                mvwControls.SetActiveView(vwError);
            }
        }

        protected int ForumId
        {
            get { return umbraco.presentation.nodeFactory.Node.GetCurrent().Id; }
        }
    }
}